<?
function uft8html2utf8( $s ) {
	if ( !function_exists('uft8html2utf8_callback') ) {
		function uft8html2utf8_callback($t) {
			$dec = $t[1];
			if ($dec < 128) {
				$utf = chr($dec);
			} else if ($dec < 2048) {
				$utf = chr(192 + (($dec - ($dec % 64)) / 64));
				$utf .= chr(128 + ($dec % 64));
			} else {
				$utf = chr(224 + (($dec - ($dec % 4096)) / 4096));
				$utf .= chr(128 + ((($dec % 4096) - ($dec % 64)) / 64));
				$utf .= chr(128 + ($dec % 64));
			}
			return $utf;
		}
	}
	return preg_replace_callback('|&#([0-9]{1,});|', 'uft8html2utf8_callback', $s );
}

function addMe2DaySkin($target, $mother) {
	global $entryView;
	requireComponent("Tattertools.Function.misc");
	$me2day = getMe2Day();

	return $target.$me2day;
}

function addMe2DaySB($parameter) {
	global $configVal;
	requireComponent( "Tattertools.Function.misc");
	$data = misc::fetchConfigVal($configVal);

	if (isset($parameter['preview'])) {
		// preview mode
		$retval = "미투데이에 올린 자신의 글을 확인할 수 있습니다.";
		return $retval;
	}

	$me2day = getMe2Day();

	if($data['sb_use'] == 'T') {
		return $me2day;
	}return;
}

function getMe2Day(){
	global $pluginURL, $entryView, $configVal;
	requireComponent('Eolin.PHP.HTTPRequest');
	requireComponent('Tattertools.Function.misc');
	requireComponent('Eolin.PHP.Core');
	$data = misc::fetchConfigVal($configVal);

	$me2day_id=split(',',$data['me2day_url']);
	for($i=0; $i < count($me2day_id); $i++) {
		$me2day_url = 'http://me2day.net/'.$me2day_id[$i];
		$me2day_rss = $me2day_url.'/rss';
		$request = new HTTPRequest($me2day_rss);

		$request->timeout = 1;
		if ($request->send()){
			$rst = $request->responseText;
		}

//		$rst = html_entity_decode($rst);
		$rst = uft8html2utf8($rst);

		$xmls = new XMLStruct();
		$xmls->open($rst);
		if($xmls->doesExist('/rss/channel/title')) {
			$title=$xmls->getValue('/rss/channel/title');
		}

		if($xmls->doesExist('/rss/channel/link')) {
			$link=$xmls->getValue('/rss/channel/link');
		}

		$rankicon = ($data['icon_use']=='T')?" style=\"margin:4px 0px 0px 0px;padding:0px;list-style:none;margin-left:1px;\"":"";
		list($me2dayer, $temp) = split('님의 ', $title);
		$me2day .= $data['md_header']."\n";
		$me2day .= "<UL {$rankicon}>\n";

		$j=1;

		foreach($xmls->selectNodes('/rss/channel/item') as $value) {
			$title = $value['title'][0]['.value'];
			$description = $value['description'][0]['.value'];
			$pubdate = $value['pubDate'][0]['.value'];
			$pubdate = str_replace(' GMT', '', $pubdate);
			$link = $value['link'][0]['.value'];
			$guid = $value['guid'][0]['.value'];
			$author = $value['author'][0]['.value'];

			$date = date('Y년 m월 d일', strtotime($pubdate));
			$time = date('H:i:s', strtotime($pubdate));
			$description = strip_tags($description);
			$description = htmlspecialchars(UTF8::lessenAsEm($description, $data['title_len']));
			$rankicon = ($data['icon_use']=='T')?" style=\"background:url({$pluginURL}/icon/{$j}.gif) no-repeat 0px 3px;padding-left:13px;\"":"";
			$me2day .= "\t<LI {$rankicon}>";
			$me2day .= ($data['disp_date'])?"$date - ":"";
			$me2day .= "<A href='$me2day_url' target='_blank'>$me2dayer</A>: ";
			$me2day .= "<A href='$link' target='_blank' title='$date $time'>$description</A>";
			$me2day .= ($data['disp_time'])?"($time)\n":"\n";
			$j++;
			if($j > $data['title_num']) break;
		}

		$me2day .= "</UL>\n";
		$me2day .= $data['md_footer'];
	}

	return $me2day;
}

function Me2DayConfig_ko($plugin) {
	global $service;
	
	$manifest = '';
	
	$manifest .= '<?xml version="1.0" encoding="utf-8"?>'.CRLF;
	$manifest .= '<config dataValHandler="">'.CRLF;
	$manifest .= '	<window width="600" height="800" />'.CRLF;
	
	$manifest .= '		<fieldset legend="미투데이 설정">'.CRLF;
	$manifest .= '		<field title="미투데이 주소:" name="me2day_url" type="text" value="" size="50">';
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				자신의 미투데이 주소를 입력합니다. 자신의 미투데이 주소가 <A HREF="http://me2day.net/doa">http://me2day.net/doa</A>라면 <B>doa</B>를 입력하면 됩니다. 하나 이상의 주소를 입력하려면 주소와 주소를 쉼표로 구분(예: <B>doa,taemy</B>)하면 됩니다. 주소와 주소 사이에는 공백이 있어서는 안됩니다.'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="목록 설정">'.CRLF;
	$manifest .= '		<field title="글의 수:" name="title_num" type="text" value="3" size="2" />';
	$manifest .= '		<field title="글자 수:" name="title_len" type="text" value="80" size="2">';
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				<B>글의 수</B>에는 목록에 표시할 글의 수를 지정하고 <B>글자 수</B>에는 글 하나당 표시할 글자 수를 입력합니다.'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="아이콘 설정">'.CRLF;
	$manifest .= '			<field title="아이콘:" name="icon_use" type="radio">';
	$manifest .= '			<op value="T" checked="checked">사용</op>'.CRLF;
	$manifest .= '			<op value="F" >사용 안 함</op>'.CRLF;
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				목록 앞의 불릿 대신에 숫자 아이콘을 사용합니다. 아이콘을 바꾸려면 플러그인이 설치된 폴더의 icon이라는 폴더의 아이콘을 덮어쓰면 됩니다'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="날짜 및 시간">'.CRLF;
	$manifest .= '			<field title="날짜 및 시간:" name="date_time" type="checkbox">';
	$manifest .= '			<op name="disp_date" value="1">날짜</op>'.CRLF;
	$manifest .= '			<op name="disp_time" value="1">시간</op>'.CRLF;
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				글 앞에 날짜 또는 시간을 표시합니다. 모두 선택하면 날짜와 시간 모두 표시됩니다. 표시되는 형식은 <B>날짜 - 글 제목(시간)</B>입니다.'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="미투데이 머릿말">'.CRLF;
	$manifest .= '		<field title="* 사용중인 skin.html 참고" name="md_header" cols="51" rows="2"  type="textarea" titledirection="bk" ><![CDATA[<fieldset><legend>미투데이</legend>]]></field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;
	$manifest .= '		<fieldset legend="미투데이 꼬릿말">'.CRLF;
	$manifest .= '		<field title="* 사용중인 skin.html 참고" name="md_footer" cols="51" rows="2"  type="textarea" titledirection="bk" ><![CDATA[</fieldset>]]></field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '		<fieldset legend="사이드바 설정">'.CRLF;
	$manifest .= '			<field title="사이드바:" name="sb_use" type="radio">';
	$manifest .= '			<op value="T" checked="checked">사용</op>'.CRLF;
	$manifest .= '			<op value="F" >사용 안 함</op>'.CRLF;
	$manifest .= '			<caption>'.CRLF;
	$manifest .= '				<![CDATA['.CRLF;
	$manifest .= '				사이드바를 사용할 사람은 스킨에서 치환자를 지우고 <B>사용</B>을 선택합니다. 치환자를 사용할 사람은 <B>사이드바를 사용 안 함으로 설정</B>하고 <B>치환자</B>를 스킨 파일의 원하는 위치에 삽입하면 됩니다.<BR><BR>이 플러그인에 대한 더 자세한 정보는 <A href="http://offree.net/entry/미투와-블로그를-하나로-태터툴즈-미투데이-플러그인" target="_blank">미투와 블로그를 하나로, 태터툴즈 미투데이 플러그인</A>을 읽어보기 바랍니다.'.CRLF;
	$manifest .= '				]]>'.CRLF;
	$manifest .= '			</caption>'.CRLF;
	$manifest .= '		</field>'.CRLF;
	$manifest .= '		</fieldset>'.CRLF;

	$manifest .= '</config>';
	
	return $manifest;
}

?>